$("document").ready(function(){

    // ***************  INITIALISATION
    $("tr.block-preview").css("display" , "none");
    $("a[href=#]").click(function(a){
        a.preventDefault();
    });

    // ***************   RENDERER
    $("table.renderer").hide();
    $("#"+$("#selectRenderer option:selected").val()).show();
    $("#selectRenderer").change(function(){
        $(".renderer").hide();
        $("#"+$(this).val()).toggle();
        return false;
    });
    $("#render").click(function(){
        var url = $(this).attr("data-url") + "?accept=" + $("#selectRenderer option:selected").val();
        $("*[data-argument]").each( function(){
            if ($(this).val() != '') {
                url += "&" + $(this).attr("data-argument") + "=" + $(this).val();
            }
        });
        window.open(url);
    });


    // init xpath
    function initXpathLink() {
        // *************** COPY XPATH
        $("a[data-xpath]").mouseover( function(){
            var input = $(this).closest("td").find("input").eq(0);
            $(input).val($(this).attr("data-xpath"));
            return false;
        });
        $("a[data-xpath]").click( function(){
            var input = $(this).closest("td").find("input").eq(0);
            $(input).val($(this).attr("data-xpath"));
            $(input).focus().select();
            return false;
        });
    }
    initXpathLink();


    // ***************
    $("i.fa-selected").click(function(){
        $(this).closest("table").find(".block-preview").eq(0).toggle();
    });

    // *************** OUTPUT + SKELETON
    $("*[data-url]").click(function() {
        // Gestion du bouton on/off et icone de sélection
        $(this).closest("th").find(".active").each(function(){ $(this).removeClass("active") }); // supprime tous les actives
        var iconSelected =  $($(this).find("i").get(0)).attr("class") + " fa-selected"; // crée les classes de l'icone de destination
        $($(this).closest("th").find("i.fa-selected").get(0)).attr("class" , iconSelected); // affecte la classe à la destination

        var elemSelected = ( $(this).prop("tagName").toLowerCase() == "button" ) ? $(this)  : $(this).parent() ;
        if ( !$(elemSelected).hasClass("active") ){
            $(elemSelected).addClass("active");
        }
        else {
            $(elemSelected).removeClass("active");
        }
        var preview = $(this).closest(".plugin").find(".block-preview").eq(0);
        $(preview).show();

        var target = $(preview).find(".pre-preview")
        $(target).html("loading...");
        $(preview).find(".div-xpath").val("");

        getXml( $(this).attr("data-url") , target );
    });

    // *************** RECUPERATION DU XML A LA DEMANDE
    function getXml( fromUrl , htmlTarget ){
        $.get( fromUrl , getViewArguments() )
            .done(function( result ) {
                $(htmlTarget).html( result );
                initXpathLink();
            })
            .fail(function(error) {
                if (error.responseText != '') {
                    $(htmlTarget).html("Error loading data: <b>" + error.responseText + "</b>");
                } else {
                    $(htmlTarget).html("Error loading data: <b>server does not respond</b>");
                }
            });
    }

    // *************** PASSAGE D'ARGUMENTS
    function getViewArguments(){
        var obj = new Object();
        $("*[data-argument]").each( function(){
            if ($(this).val() != '') {
                obj[ $(this).attr("data-argument") ] = $(this).val();
            }
        });
        return obj;
    }

    $('*[data-language]').each(function () {
        var editor = ace.edit($(this)[0]);
        editor.renderer.setShowGutter(true);
        editor.setOptions({
            minLines: 2,
            maxLines: 10
        });
        editor.getSession().setMode("ace/mode/" + $(this).data("language"));
        editor.getSession().setUseWrapMode(true);
        editor.setHighlightActiveLine(false);
        editor.setReadOnly(true);
        editor.setTheme("ace/theme/chrome");
    });
});
