<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:lav="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd">
    <!-- This template creates data views for non-regression testing -->
    <xsl:template match="lav:view-template[contains(@stylesheet,'NonRegressionTemplate.xsl')]">
        <xsl:variable name="test-suite" select="lav:parameter[@name='test-suite']/text()"/>
        <xsl:if test="not($test-suite)">
            <xsl:message terminate="yes">View template '<xsl:value-of select="@stylesheet"/>' is missing required parameter: test-suite</xsl:message>
        </xsl:if>
        <xsl:variable name="expected" select="lav:parameter[@name='expected']/text()"/>
        <xsl:if test="not($expected)">
            <xsl:message terminate="yes">View template '<xsl:value-of select="@stylesheet"/>' is missing required parameter: expected</xsl:message>
        </xsl:if>

        <view><xsl:copy-of select="@*[not(local-name()='stylesheet')] | lav:*[not(self::lav:parameter)]"/>
            <namespace prefix="e" uri="http://software.in2p3.fr/lavoisier/entries.xsd"/>
            <argument name="view"/>
            <connector type="DiffConnector">
                <parameter name="document1" eval="document('{$expected}')/test-suite/entries[@view=$view]/*"/>
                <parameter name="document2" eval="view('skeleton', arguments() | document('{$test-suite}')/e:test-suite/e:entries[@view=$view]/e:entry)"/>
            </connector>
        </view>
        <view name="{@name}_expected"><xsl:copy-of select="lav:*[not(self::lav:parameter)]"/>
            <namespace prefix="e" uri="http://software.in2p3.fr/lavoisier/entries.xsd"/>
            <connector type="FileConnector">
                <parameter name="path"><xsl:value-of select="$test-suite"/></parameter>
            </connector>
            <processors>
                <insert match="/e:test-suite/e:entries[* or not(*)]" nodes="view('skeleton', * | entry('view', @view))"/>
                <remove match="/e:test-suite/e:entries/e:entry"/>
                <processor type="ChangeNamespaceProcessor" match="/e:test-suite/e:entries"/>
                <processor type="ChangeNamespaceProcessor" match="/e:test-suite"/>
            </processors>
        </view>
    </xsl:template>
</xsl:stylesheet>