<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="cfg">
    <xsl:output method="xml" omit-xml-declaration="yes"/>
    <xsl:variable name="VERSION">10</xsl:variable>

    <xsl:template match="cfg:processors/cfg:*/@*[local-name()='nodes' or local-name()='context' or local-name()='values']">
        <xsl:attribute name="match"><xsl:value-of select="."/></xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:processors/cfg:*/@new-nodes">
        <xsl:attribute name="nodes"><xsl:value-of select="."/></xsl:attribute>
    </xsl:template>

    <xsl:template match="cfg:for">
        <insert match="{concat(@nodes,'[* or not(*)]')}">
            <xsl:apply-templates/>
        </insert>
    </xsl:template>
    <xsl:template match="cfg:processor[@type='InsertXmlProcessor']">
        <xsl:variable name="xml" select="cfg:parameter[@name='xml']/@eval"/>
        <xsl:variable name="select" select="cfg:parameter[@name='select']/@eval"/>
        <xsl:choose>
            <xsl:when test="$select and contains($xml, ')/*')">
                <insert match="{concat(@match,'[*]')}" nodes="{concat(substring-before($xml,')/*'), ')', $select)}"/>
            </xsl:when>
            <xsl:when test="$select">
                <insert match="{concat(@match,'[*]')}" nodes="{concat($xml, $select)}"/>
            </xsl:when>
            <xsl:otherwise>
                <insert match="{concat(@match,'[*]')}" nodes="{$xml}"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <!-- common -->
    <xsl:template match="/cfg:config/@version">
        <xsl:attribute name="version">
            <xsl:value-of select="$VERSION"/>
        </xsl:attribute>
    </xsl:template>
    <xsl:template match="@* | comment()" priority="-1">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*" priority="-1">
        <xsl:copy><xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>