<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:cfg="http://software.in2p3.fr/lavoisier/config.xsd"
                xmlns="http://software.in2p3.fr/lavoisier/config.xsd"
                exclude-result-prefixes="cfg">
    <xsl:output method="xml" omit-xml-declaration="yes"/>
    <xsl:variable name="VERSION">11</xsl:variable>

    <xsl:template match="cfg:connector/@type[.='StringListConnector']">
        <xsl:attribute name="type">XMLConnector</xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:connector/@type[.='StringMapConnector']">
        <xsl:attribute name="type">XMLConnector</xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:connector[@type='StringConnector']">
        <xsl:copy>
            <xsl:apply-templates select="@*|*|text()|comment()"/>
        </xsl:copy>
        <serializer type="EncapsulateSerializer"/>
    </xsl:template>

    <xsl:template match="cfg:processor/@type[.='GroupProcessor']">
        <xsl:attribute name="type">SelectGroupByProcessor</xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:processor/@type[.='UniqueProcessor']">
        <xsl:attribute name="type">SelectDistinctProcessor</xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:processor/@type[.='SelectAncestorProcessor']">
        <xsl:attribute name="type">SelectIfDescendantProcessor</xsl:attribute>
    </xsl:template>
    <xsl:template match="cfg:processor/@type[.='InsertAsParentProcessor']">
        <xsl:attribute name="type">InsertParentProcessor</xsl:attribute>
    </xsl:template>

    <xsl:template match="cfg:unique">
        <select><xsl:copy-of select="@match"/>
            <distinct>
                <xsl:copy-of select="@sort | @descending"/>
            </distinct>
        </select>
    </xsl:template>
    <xsl:template match="cfg:aggregate/cfg:element">
        <to-last-child>
            <xsl:apply-templates select="@*"/>
        </to-last-child>
    </xsl:template>

    <!-- common -->
    <xsl:template match="/cfg:config/@version">
        <xsl:attribute name="version">
            <xsl:value-of select="$VERSION"/>
        </xsl:attribute>
    </xsl:template>
    <xsl:template match="@* | comment()" priority="-1">
        <xsl:copy-of select="."/>
    </xsl:template>
    <xsl:template match="*" priority="-1">
        <xsl:copy><xsl:apply-templates select="@*"/>
            <xsl:apply-templates/>
        </xsl:copy>
    </xsl:template>
</xsl:stylesheet>