<?xml version="1.0" encoding="UTF-8"?><xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xalan="http://xml.apache.org/xalan" xmlns:render="http://software.in2p3.fr/lavoisier/rendering.xsd" version="1.0">
    <!-- generated by xslRowColumn-2-xslHtml.xsl --><include xmlns="http://www.w3.org/1999/XSL/Transform" href="/resource/xsl/head.xsl"/><include xmlns="http://www.w3.org/1999/XSL/Transform" href="/lavoisier/navbar"/>
    <xsl:output method="html" indent="yes" xalan:indent-amount="4"/>
    <xsl:strip-space elements="*"/><!-- prevents text() function to ignore the text nodes other than 1st one -->
    <xsl:param name="view">Default rendering</xsl:param>

    <xsl:variable name="lower">abcdefghijklmnopqrstuvwxyz</xsl:variable>
    <xsl:variable name="UPPER">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>

    <!-- rows are in level 2 -->
    <xsl:variable name="map2">map2</xsl:variable>
    <xsl:key name="map2" match="/*/*[@* or text()!='' or */text()!='']" use="concat('{',namespace-uri(),'}',local-name())"/>

    <xsl:variable name="rows2">rows2</xsl:variable>
    <xsl:key name="rows2" match="/*/*[key('map2',concat('{',namespace-uri(),'}',local-name()))[2]]" use="concat('{',namespace-uri(),'}',local-name())"/>

    <xsl:variable name="rows3">rows3</xsl:variable>
    <xsl:key name="rows3" match="/*/*[key('map2',concat('{',namespace-uri(),'}',local-name()))[2]]/*[text()!='']" use="concat('{',namespace-uri(..),'}',local-name(..), '{',namespace-uri(),'}',local-name())"/>

    <xsl:template match="/">
        <x:html xmlns:x="http://www.w3.org/1999/xhtml"><head xmlns="http://www.w3.org/1999/xhtml"><title><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="$view"/></title><style type="text/css">
            h2            {text-align : center;}
            TD             {text-align: left;}
            TD.number      {text-align: right;}
        </style><call-template xmlns="http://www.w3.org/1999/XSL/Transform" name="head"/></head><body xmlns="http://www.w3.org/1999/xhtml"><call-template xmlns="http://www.w3.org/1999/XSL/Transform" name="navbar"/><div class="container"><h2 class="page-title text-center"><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="$view"/></h2><div style="margin-top:50px">
            <xsl:variable name="f2" select="/*/*[not(key($map2,concat('{',namespace-uri(),'}',local-name()))[2]) and count(/*/*)>1]"/>
            <xsl:variable name="fields" select="/*/@* | /*/text()[.!=''] | $f2/@* | $f2/text()[.!=''] | $f2/*/text()[.!='']"/>
            <xsl:if test="$fields">
                <ul>
                    <xsl:apply-templates select="$fields" mode="field"/>
                </ul>
            </xsl:if>

            <xsl:variable name="r2" select="/*/*[key($map2,concat('{',namespace-uri(),'}',local-name()))[2]]"/>
            <xsl:choose>
                <!-- rows are in level 2 -->
                <xsl:when test="$r2">
                    <xsl:variable name="c2" select="/*/*[generate-id()=generate-id(key($rows2,                         concat('{',namespace-uri(),'}',local-name()))[1])]"/>
                    <xsl:variable name="c3" select="/*/*/*[generate-id()=generate-id(key($rows3,                         concat('{',namespace-uri(..),'}',local-name(..), '{',namespace-uri(),'}',local-name()))[1])]"/>
                    <xsl:variable name="column_names" select="$c2/@* | $c2/text()[.!=''] | $c3/text()[.!='']"/>
                    <table class="table table-bordered table-striped table-sorted table-hover">
                        <thead><tr>
                            <th>Position</th>
                            <xsl:apply-templates select="$column_names" mode="column_label"/>
                        </tr></thead>
                        <xsl:for-each select="$r2">
                            <tr>
                                <!-- column Position -->
                                <xsl:choose>
                                    <xsl:when test="*">
                                        <td><a>
                                            <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                                                <xsl:if xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" test="not(/e:entries)">/lavoisier/<xsl:value-of select="$view"/>/*/</xsl:if>
                                                <xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>*[<xsl:value-of xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" select="position()"/>]/*?accept=rowcol<xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>
                                            </attribute>
                                            <xsl:value-of select="position()"/>
                                        </a></td>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <td>
                                            <xsl:value-of select="position()"/>
                                        </td>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <!-- other columns -->
                                <xsl:apply-templates select="$column_names" mode="column">
                                    <xsl:with-param name="row" select="."/>
                                </xsl:apply-templates>
                            </tr>
                        </xsl:for-each>
                    </table>
                </xsl:when>

                <!-- may have a single row -->
                <xsl:when test="count(/*/*) = 1">
                    <xsl:variable name="c2" select="/*/*"/>
                    <xsl:variable name="c3" select="/*/*/*[text()!='']"/>
                    <xsl:variable name="column_names" select="$c2/@* | $c2/text()[.!=''] | $c3/text()[.!='']"/>
                    <table class="table table-bordered table-striped table-sorted table-hover">
                        <thead><tr>
                            <th>Position</th>
                            <xsl:apply-templates select="$column_names" mode="column_label"/>
                        </tr></thead>
                        <xsl:for-each select="/*/*">
                            <tr>
                                <!-- column Position -->
                                <xsl:choose>
                                    <xsl:when test="*">
                                        <td><a>
                                            <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                                                <xsl:if xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" test="not(/e:entries)">/lavoisier/<xsl:value-of select="$view"/>/*/</xsl:if>
                                                <xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>*[<xsl:value-of xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" select="position()"/>]/*?accept=rowcol<xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>
                                            </attribute>
                                            <xsl:value-of select="position()"/>
                                        </a></td>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <td>
                                            <xsl:value-of select="position()"/>
                                        </td>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <!-- other columns -->
                                <xsl:apply-templates select="$column_names" mode="column">
                                    <xsl:with-param name="row" select="."/>
                                </xsl:apply-templates>
                            </tr>
                        </xsl:for-each>
                    </table>
                </xsl:when>

                <!-- information may be deeper -->
                <xsl:when test="/*/*/*">
                    <table class="table table-bordered table-striped table-sorted table-hover">
                        <thead><tr>
                            <th>Position</th>
                            <th>Element name</th>
                        </tr></thead>
                        <xsl:for-each select="/*/*">
                            <tr>
                                <!-- column Position -->
                                <xsl:choose>
                                    <xsl:when test="*">
                                        <td><a>
                                            <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                                                <xsl:if xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" test="not(/e:entries)">/lavoisier/<xsl:value-of select="$view"/>/*/</xsl:if>
                                                <xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>*[<xsl:value-of xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd" select="position()"/>]/*?accept=rowcol<xsl:text xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd"/>
                                            </attribute>
                                            <xsl:value-of select="position()"/>
                                        </a></td>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <td>
                                            <xsl:value-of select="position()"/>
                                        </td>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <!-- other columns -->
                                <td><xsl:value-of select="local-name()"/></td>
                            </tr>
                        </xsl:for-each>
                    </table>
                </xsl:when>
            </xsl:choose>
        </div></div></body></x:html>
    </xsl:template>

    <xsl:template match="/*/text() | /*/*/text()" mode="field">
        <li xmlns="http://www.w3.org/1999/xhtml"><b><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="local-name(..)"/>: </b>
            <xsl:value-of select="normalize-space()"/>
        </li>
    </xsl:template>
    <xsl:template match="/*/*/*/text()" mode="field">
        <li xmlns="http://www.w3.org/1999/xhtml"><b><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="concat(local-name(../..),'_',local-name(..))"/>: </b>
            <xsl:value-of select="normalize-space()"/>
        </li>
    </xsl:template>
    <xsl:template match="/*/@*" mode="field">
        <li xmlns="http://www.w3.org/1999/xhtml"><b><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="local-name()"/>: </b>
            <xsl:value-of select="."/>
        </li>
    </xsl:template>
    <xsl:template match="/*/*/@*" mode="field">
        <li xmlns="http://www.w3.org/1999/xhtml"><b><value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="concat(local-name(..), translate(substring(local-name(),1,1),$lower,$UPPER), substring(local-name(),2))"/>: </b>
            <xsl:value-of select="."/>
        </li>
    </xsl:template>

    <xsl:template match="/*/*/text()" mode="column_label">
        <xsl:apply-templates select="." mode="LABEL">
            <xsl:with-param name="name" select="local-name(..)"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="/*/*/*/text()" mode="column_label">
        <xsl:apply-templates select="." mode="LABEL">
            <xsl:with-param name="name" select="concat(local-name(../..),'_',local-name(..))"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="/*/*/@*" mode="column_label">
        <xsl:apply-templates select="." mode="LABEL">
            <xsl:with-param name="name" select="concat(local-name(..), translate(substring(local-name(),1,1),$lower,$UPPER), substring(local-name(),2))"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="/*/*/*/@*" mode="column_label">
        <xsl:apply-templates select="." mode="LABEL">
            <xsl:with-param name="name" select="concat(local-name(../..),'_',local-name(..), translate(substring(local-name(),1,1),$lower,$UPPER), substring(local-name(),2))"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="@* | text()" mode="LABEL">
        <xsl:param name="name"/>
        <th xmlns="http://www.w3.org/1999/xhtml">
            <xsl:if test=".!='' and translate(.,'0123456789.','')=''">

            </xsl:if>
            <xsl:value-of select="$name"/>
            (<xsl:value-of select="$name"/>)</th>
    </xsl:template>

    <xsl:template match="/*/*/text()" mode="column">
        <xsl:param name="row"/>
        <xsl:variable name="level2" select="current()/.."/>
        <xsl:variable name="value" select="normalize-space($row             /self::*[namespace-uri()=namespace-uri($level2) and local-name()=local-name($level2)]             /text())"/>
        <xsl:choose>
            <xsl:when test="parent::*/*">
                <td xmlns="http://www.w3.org/1999/xhtml"><a>
                    <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                        <xsl:apply-templates select="." mode="ANCESTORS"/>
                        <xsl:text/>[text()='<xsl:value-of select="$value"/>']/*?accept=rowcol<xsl:text/>
                    </attribute>
                    <xsl:value-of select="$value"/>
                </a></td>
            </xsl:when>
            <xsl:otherwise>
                <td xmlns="http://www.w3.org/1999/xhtml">
                    <xsl:value-of select="$value"/>
                </td>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="/*/*/*/text()" mode="column">
        <xsl:param name="row"/>
        <xsl:variable name="level2" select="current()/../.."/>
        <xsl:variable name="level3" select="current()/.."/>
        <xsl:variable name="value" select="normalize-space($row             /self::*[namespace-uri()=namespace-uri($level2) and local-name()=local-name($level2)]             /*[namespace-uri()=namespace-uri($level3) and local-name()=local-name($level3)]             /text())"/>
        <td xmlns="http://www.w3.org/1999/xhtml"><a>
            <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                <xsl:apply-templates select="parent::*" mode="ANCESTORS"/>
                <xsl:text/>[<xsl:apply-templates select="parent::*" mode="SELF"/>/text()='<xsl:value-of select="$value"/>']/*?accept=rowcol<xsl:text/>
            </attribute>
            <xsl:value-of select="$value"/>
        </a></td>
    </xsl:template>
    <xsl:template match="/*/*/@*" mode="column">
        <xsl:param name="row"/>
        <xsl:variable name="level2" select="current()/.."/>
        <xsl:variable name="attribute" select="current()"/>
        <xsl:variable name="value" select="normalize-space($row             /self::*[namespace-uri()=namespace-uri($level2) and local-name()=local-name($level2)]             /@*[local-name()=local-name($attribute)])"/>
        <xsl:choose>
            <xsl:when test="parent::*/*">
                <td xmlns="http://www.w3.org/1999/xhtml"><a>
                    <attribute xmlns="http://www.w3.org/1999/XSL/Transform" name="href">
                        <xsl:apply-templates select="." mode="ANCESTORS"/>
                        <xsl:text/>[@<xsl:value-of select="local-name()"/>='<xsl:value-of select="$value"/>']/*?accept=rowcol<xsl:text/>
                    </attribute>
                    <xsl:value-of select="$value"/>
                </a></td>
            </xsl:when>
            <xsl:otherwise>
                <td xmlns="http://www.w3.org/1999/xhtml">
                    <xsl:value-of select="$value"/>
                </td>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="* | @* | text()" mode="ANCESTORS">
        <xsl:choose xmlns:e="http://software.in2p3.fr/lavoisier/entries.xsd">
            <xsl:when test="/e:entries">*</xsl:when>
            <xsl:otherwise>
                <xsl:text/>/lavoisier/<xsl:value-of select="$view"/>
                <xsl:for-each select="ancestor::*">/<xsl:apply-templates select="." mode="SELF"/></xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="*" mode="SELF">
        <xsl:choose>
            <xsl:when test="not(parent::*)">*</xsl:when>
            <xsl:when test="boolean(namespace-uri())">*[local-name()='<xsl:value-of select="local-name()"/>']</xsl:when>
            <xsl:otherwise><xsl:value-of select="local-name()"/></xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>