<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:r="http://software.in2p3.fr/lavoisier/rendering.xsd">
    <xsl:include href="/resource/xsl/head.xsl"/>
    <xsl:include href="/lavoisier/navbar"/>
    <xsl:output method="html"/>

    <xsl:template match="/">
        <html xmlns="http://www.w3.org/1999/xhtml">
            <xsl:call-template name="head"/>
            <body>
                <xsl:call-template name="navbar"/>
                <div class="container">
                    <xsl:apply-templates/>
                </div>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="r:rendering">
        <h2 class="page-title text-center"><xsl:value-of select="@title"/></h2>
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="r:rows">
        <table class="table table-bordered table-striped table-sorted table-hover">
            <xsl:apply-templates select="r:column_labels"/>
            <tbody>
                <xsl:apply-templates select="r:row"/>
            </tbody>
        </table>
    </xsl:template>

    <xsl:template match="r:column_labels">
        <thead>
            <xsl:apply-templates/>
        </thead>
    </xsl:template>
    <xsl:template match="r:column_label">
        <th>
            <xsl:apply-templates/>
        </th>
    </xsl:template>

    <xsl:template match="r:row">
        <tr>
            <xsl:apply-templates/>
        </tr>
    </xsl:template>
    <xsl:template match="r:column[@link]">
        <td>
            <a href="{@link}">
                <xsl:apply-templates/>
            </a>
        </td>
    </xsl:template>
    <xsl:template match="r:column[not(@link)]">
        <td>
            <xsl:apply-templates/>
        </td>
    </xsl:template>
</xsl:stylesheet>