<xsl:stylesheet version="1.0"  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:include href="/resource/xsl/head.xsl"/>
    <xsl:include href="/lavoisier/navbar"/>
    <xsl:output method="html" encoding="utf-8" indent="yes" />

    <xsl:template match="/">
        <html>
            <xsl:call-template name="head"/>
            <body>
                <xsl:call-template name="navbar"/>
                <div class="container">
                    <h1>Bug report #<xsl:value-of select="issue/id/text()"/> sent to developers</h1>
                    <table>
                        <xsl:apply-templates select="issue/*"/>
                    </table>
                </div>
            </body>
        </html>
    </xsl:template>

    <xsl:template match="*[@name]">
        <tr>
            <th><xsl:value-of select="local-name()"/></th>
            <td><xsl:value-of select="@name"/></td>
        </tr>
    </xsl:template>

    <xsl:template match="description">
        <tr>
            <th><xsl:value-of select="local-name()"/></th>
            <td><pre><xsl:value-of select="text()"/></pre></td>
        </tr>
    </xsl:template>

    <xsl:template match="*"/>
</xsl:stylesheet>